<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN"
"http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head><meta http-equiv="content-type" content="text/html; charset=utf-8" />
<title>[152623] contrib/mp-buildbot</title>
</head>
<body>

<style type="text/css"><!--
#msg dl.meta { border: 1px #006 solid; background: #369; padding: 6px; color: #fff; }
#msg dl.meta dt { float: left; width: 6em; font-weight: bold; }
#msg dt:after { content:':';}
#msg dl, #msg dt, #msg ul, #msg li, #header, #footer, #logmsg { font-family: verdana,arial,helvetica,sans-serif; font-size: 10pt;  }
#msg dl a { font-weight: bold}
#msg dl a:link    { color:#fc3; }
#msg dl a:active  { color:#ff0; }
#msg dl a:visited { color:#cc6; }
h3 { font-family: verdana,arial,helvetica,sans-serif; font-size: 10pt; font-weight: bold; }
#msg pre { overflow: auto; background: #ffc; border: 1px #fa0 solid; padding: 6px; }
#logmsg { background: #ffc; border: 1px #fa0 solid; padding: 1em 1em 0 1em; }
#logmsg p, #logmsg pre, #logmsg blockquote { margin: 0 0 1em 0; }
#logmsg p, #logmsg li, #logmsg dt, #logmsg dd { line-height: 14pt; }
#logmsg h1, #logmsg h2, #logmsg h3, #logmsg h4, #logmsg h5, #logmsg h6 { margin: .5em 0; }
#logmsg h1:first-child, #logmsg h2:first-child, #logmsg h3:first-child, #logmsg h4:first-child, #logmsg h5:first-child, #logmsg h6:first-child { margin-top: 0; }
#logmsg ul, #logmsg ol { padding: 0; list-style-position: inside; margin: 0 0 0 1em; }
#logmsg ul { text-indent: -1em; padding-left: 1em; }#logmsg ol { text-indent: -1.5em; padding-left: 1.5em; }
#logmsg > ul, #logmsg > ol { margin: 0 0 1em 0; }
#logmsg pre { background: #eee; padding: 1em; }
#logmsg blockquote { border: 1px solid #fa0; border-left-width: 10px; padding: 1em 1em 0 1em; background: white;}
#logmsg dl { margin: 0; }
#logmsg dt { font-weight: bold; }
#logmsg dd { margin: 0; padding: 0 0 0.5em 0; }
#logmsg dd:before { content:'\00bb';}
#logmsg table { border-spacing: 0px; border-collapse: collapse; border-top: 4px solid #fa0; border-bottom: 1px solid #fa0; background: #fff; }
#logmsg table th { text-align: left; font-weight: normal; padding: 0.2em 0.5em; border-top: 1px dotted #fa0; }
#logmsg table td { text-align: right; border-top: 1px dotted #fa0; padding: 0.2em 0.5em; }
#logmsg table thead th { text-align: center; border-bottom: 1px solid #fa0; }
#logmsg table th.Corner { text-align: left; }
#logmsg hr { border: none 0; border-top: 2px dashed #fa0; height: 1px; }
#header, #footer { color: #fff; background: #636; border: 1px #300 solid; padding: 6px; }
#patch { width: 100%; }
#patch h4 {font-family: verdana,arial,helvetica,sans-serif;font-size:10pt;padding:8px;background:#369;color:#fff;margin:0;}
#patch .propset h4, #patch .binary h4 {margin:0;}
#patch pre {padding:0;line-height:1.2em;margin:0;}
#patch .diff {width:100%;background:#eee;padding: 0 0 10px 0;overflow:auto;}
#patch .propset .diff, #patch .binary .diff  {padding:10px 0;}
#patch span {display:block;padding:0 10px;}
#patch .modfile, #patch .addfile, #patch .delfile, #patch .propset, #patch .binary, #patch .copfile {border:1px solid #ccc;margin:10px 0;}
#patch ins {background:#dfd;text-decoration:none;display:block;padding:0 10px;}
#patch del {background:#fdd;text-decoration:none;display:block;padding:0 10px;}
#patch .lines, .info {color:#888;background:#fff;}
--></style>
<div id="msg">
<dl class="meta">
<dt>Revision</dt> <dd><a href="https://trac.macports.org/changeset/152623">152623</a></dd>
<dt>Author</dt> <dd>larryv@macports.org</dd>
<dt>Date</dt> <dd>2016-09-13 07:25:38 -0700 (Tue, 13 Sep 2016)</dd>
</dl>

<h3>Log Message</h3>
<pre>mpbb: Move parseopt to support library</pre>

<h3>Modified Paths</h3>
<ul>
<li><a href="#contribmpbuildbotfunctions">contrib/mp-buildbot/functions</a></li>
<li><a href="#contribmpbuildbotmpbb">contrib/mp-buildbot/mpbb</a></li>
</ul>

</div>
<div id="patch">
<h3>Diff</h3>
<a id="contribmpbuildbotfunctions"></a>
<div class="modfile"><h4>Modified: contrib/mp-buildbot/functions (152622 => 152623)</h4>
<pre class="diff"><span>
<span class="info">--- contrib/mp-buildbot/functions        2016-09-13 13:19:35 UTC (rev 152622)
+++ contrib/mp-buildbot/functions        2016-09-13 14:25:38 UTC (rev 152623)
</span><span class="lines">@@ -9,6 +9,74 @@
</span><span class="cx"> err() { msg error: &quot;$@&quot;; }
</span><span class="cx"> warn() { msg warning: &quot;$@&quot;; }
</span><span class="cx"> 
</span><ins>+unset GETOPT_COMPATIBLE
+if getopt -T &gt;/dev/null; then
+    # http://frodo.looijaard.name/project/getopt
+    err &quot;Cannot find an enhanced getopt(1)&quot;
+    return 3
+fi
+
+# TODO Documentation, obviously :)
+parseopt() {
+    # Be stricter about this than getopt(1) is.
+    if ! [[ ${1-} =~ ^[[:alnum:]-]+:{0,2}(,[[:alnum:]-]+:{0,2})*$ ]]; then
+        err 'Invalid argument given to parseopt'
+        return 3
+    fi
+
+    # Use &quot;--options +&quot; to prevent arguments from being rearranged.
+    local opts
+    opts=$(getopt --name &quot;$0&quot; --opt + --longopt &quot;$1&quot; -- &quot;${@:2}&quot;)
+    case $? in
+        0)
+            ;;
+        1)
+            # getopt(1) will print the bad argument to standard error.
+            echo &gt;&amp;2 &quot;Try \`$0 help' for more information.&quot;
+            return 2
+            ;;
+        *)
+            err 'getopt encountered an internal error'
+            return 3
+            ;;
+    esac
+    readonly opts
+
+    local -a validopts
+    IFS=, read -ra validopts &lt;&lt;&lt;&quot;$1&quot;
+    readonly validopts=(&quot;${validopts[@]/#/--}&quot;)
+
+    eval set -- &quot;$opts&quot;
+
+    local opt validopt
+    # getopt(1) ensures that the options are always terminated with &quot;--&quot;.
+    while [[ $1 != -- ]]; do
+        opt=$1
+        shift
+        # XXX Do NOT touch anything below unless you know exactly what
+        # you're doing (http://mywiki.wooledge.org/BashFAQ/006#eval).
+        for validopt in &quot;${validopts[@]}&quot;; do
+            if [[ $validopt == &quot;$opt:&quot; || $validopt == &quot;$opt::&quot; ]]; then
+                opt=${opt#--}
+                # $1 is null for omitted optional arguments.
+                eval option_&quot;${opt//-/_}&quot;'=$1'
+                shift
+                continue 2
+            fi
+            if [[ $validopt == &quot;$opt&quot; ]]; then
+                opt=${opt#--}
+                eval option_&quot;${opt//-/_}&quot;'=1'
+                continue 2
+            fi
+        done
+        # Unreachable unless there is a bug in this function or in getopt(1).
+        err 'parseopt encountered an internal error'
+        return 3
+    done
+    # shellcheck disable=SC2034
+    args=(&quot;${@:2}&quot;)
+}
+
</ins><span class="cx"> ## Compute a failcache hash for the given port
</span><span class="cx"> #
</span><span class="cx"> # Computes and prints a hash uniquely identifying a specific state of a port's
</span></span></pre></div>
<a id="contribmpbuildbotmpbb"></a>
<div class="modfile"><h4>Modified: contrib/mp-buildbot/mpbb (152622 => 152623)</h4>
<pre class="diff"><span>
<span class="info">--- contrib/mp-buildbot/mpbb        2016-09-13 13:19:35 UTC (rev 152622)
+++ contrib/mp-buildbot/mpbb        2016-09-13 14:25:38 UTC (rev 152623)
</span><span class="lines">@@ -11,7 +11,7 @@
</span><span class="cx"> # Load function library
</span><span class="cx"> thisdir=$(cd &quot;$(dirname &quot;$0&quot;)&quot; &amp;&amp; pwd)
</span><span class="cx"> # shellcheck source=functions
</span><del>-. &quot;$thisdir/functions&quot;
</del><ins>+. &quot;$thisdir/functions&quot; || exit
</ins><span class="cx"> 
</span><span class="cx"> mpbb-usage() {
</span><span class="cx">     # &quot;prog&quot; is defined in mpbb-help.
</span><span class="lines">@@ -41,73 +41,6 @@
</span><span class="cx"> EOF
</span><span class="cx"> }
</span><span class="cx"> 
</span><del>-# TODO Documentation, obviously :)
-parseopt() {
-    # Be stricter about this than getopt(1) is.
-    if ! [[ ${1-} =~ ^[[:alnum:]-]+:{0,2}(,[[:alnum:]-]+:{0,2})*$ ]]; then
-        err 'Invalid argument given to parseopt'
-        return 3
-    fi
-
-    # Use &quot;--options +&quot; to prevent arguments from being rearranged.
-    local opts
-    opts=$(getopt --name &quot;$0&quot; --opt + --longopt &quot;$1&quot; -- &quot;${@:2}&quot;)
-    case $? in
-        0)
-            ;;
-        1)
-            # getopt(1) will print the bad argument to standard error.
-            echo &gt;&amp;2 &quot;Try \`$0 help' for more information.&quot;
-            return 2
-            ;;
-        *)
-            err 'getopt encountered an internal error'
-            return 3
-            ;;
-    esac
-    readonly opts
-
-    local -a validopts
-    IFS=, read -ra validopts &lt;&lt;&lt;&quot;$1&quot;
-    readonly validopts=(&quot;${validopts[@]/#/--}&quot;)
-
-    eval set -- &quot;$opts&quot;
-
-    local opt validopt
-    # getopt(1) ensures that the options are always terminated with &quot;--&quot;.
-    while [[ $1 != -- ]]; do
-        opt=$1
-        shift
-        # XXX Do NOT touch anything below unless you know exactly what
-        # you're doing (http://mywiki.wooledge.org/BashFAQ/006#eval).
-        for validopt in &quot;${validopts[@]}&quot;; do
-            if [[ $validopt == &quot;$opt:&quot; || $validopt == &quot;$opt::&quot; ]]; then
-                opt=${opt#--}
-                # $1 is null for omitted optional arguments.
-                eval option_&quot;${opt//-/_}&quot;'=$1'
-                shift
-                continue 2
-            fi
-            if [[ $validopt == &quot;$opt&quot; ]]; then
-                opt=${opt#--}
-                eval option_&quot;${opt//-/_}&quot;'=1'
-                continue 2
-            fi
-        done
-        # Unreachable unless there is a bug in this function or in getopt(1).
-        err 'parseopt encountered an internal error'
-        return 3
-    done
-    args=(&quot;${@:2}&quot;)
-}
-
-unset GETOPT_COMPATIBLE
-if getopt -T &gt;/dev/null; then
-    # http://frodo.looijaard.name/project/getopt
-    err &quot;Cannot find an enhanced getopt(1)&quot;
-    exit 3
-fi
-
</del><span class="cx"> # Process options.
</span><span class="cx"> parseopt prefix:,work-dir: &quot;$@&quot; || exit
</span><span class="cx"> 
</span></span></pre>
</div>
</div>

</body>
</html>